#[derive(Clone, PartialEq, Debug)]
pub struct Fn {
    pub ops: Vec<Op>,
    pub data: Vec<Data>,
    pub id: u64,
    pub arg_count: i32,
    pub local_count: i32,
}

#[derive(Clone, PartialEq, Debug)]
pub enum Op {
    Pop,
    PushI32(i32),
    PushU32(u32),
    PushStaticPtr(u64),
    StoreLocal(i32),
    LoadLocal(i32),
    Jump(u64),
    JumpIfFalse(u64),
    JumpIfTrue(u64),
    CallFn(u64, i32),
    CallPtr(i32),
    Return,
}

#[derive(Clone, PartialEq, Debug)]
pub struct Data {
    pub kind: DataKind,
    pub id: u64,
}

#[derive(Clone, PartialEq, Debug)]
pub enum DataKind {
    U8(Vec<u8>),
}
